<template>
    <div ref="target" v-if="isVisible">
      <slot></slot>
    </div>
</template>
  
<script>
import { ref, watchEffect } from 'vue';

export default {
  name: 'AnimateInView',
  setup() {
    const target = ref(null);
    const isVisible = ref(false);

    // Function to handle the intersection observer callback
    const handleIntersect = (entries) => {
      const entry = entries[0];
      isVisible.value = entry.isIntersecting;
    };

    // Create an Intersection Observer
    const observer = new IntersectionObserver(handleIntersect, {
      root: null,
      rootMargin: '0px',
      threshold: 0.5, // Adjust this threshold as needed
    });

    // Watch for changes to the target element
    watchEffect(() => {
      if (target.value) {
        observer.observe(target.value);
      }
    });

    return {
      isVisible,
    };
  },
};
</script>